local module, parent = torch.class('nnf.SpatialConstDiagonal', 'nn.Module')

function module:__init(nOutputPlane, inplace)
  parent.__init(self)
  self.a = torch.Tensor(1,nOutputPlane,1,1)
  self.b = torch.Tensor(1,nOutputPlane,1,1)
  self.inplace = inplace
  self:reset()
end

function module:reset()
  self.a:fill(1)
  self.b:zero()
end

function module:updateOutput(input)
  if self.inplace then
    self.output:set(input)
  else
    self.output:resizeAs(input):copy(input)
  end
  self.output:cmul(self.a:expandAs(input))
  self.output:add(self.b:expandAs(input))
  return self.output
end

function module:updateGradInput(input, gradOutput)
  if self.inplace then
    self.gradInput:set(gradOutput)
  else
    self.gradInput:resizeAs(gradOutput):copy(gradOutput)
  end
  self.gradInput:cmul(self.a:expandAs(gradOutput))
  return self.gradInput
end
