require 'nnf';

cls = {'aeroplane','bicycle','boat','bottle','bus','car',
              'chair','diningtable','motorbike',
              'sofa','train','tvmonitor'}

ds = nnf.DataSetPascal{
  image_set='train',
  datadir='datasets/VOCdevkit',
  dataset_name='Pascal3D',
  --roidbdir='data/selective_search_data',
  roidbfile='data/MAD-DM2k/voc_2012_val.t7',
  year=2012,
  classes=cls
}

ds.save_objs = true
ds:loadROIDB()

do
print('Removing images without positives')
local dont_keep = {}
for i = 1, ds:size() do
  local _, gt = ds:getGTBoxes(i)
  if #gt == 0 then
    table.insert(dont_keep, i)
  end
end
print('Found '..#dont_keep..' images without positives')
for i = #dont_keep, 1, -1 do
  table.remove(ds.img_ids, dont_keep[i])
  table.remove(ds.roidb, dont_keep[i])
end
ds.num_imgs = #ds.img_ids
end

i = 10
I = ds:getImage(i)

gt, cl, vo, anno = ds:getGTBoxes(i)

--image.display(I)
--Ic = {}
function flip_angle(x)
  return (-x)%360
end
for l = 1,gt:size(1) do
  local g = gt[l]
  --table.insert(Ic, I[{{},{g[2],g[4]},{g[1],g[3]}}])
  Ic = I[{{},{g[2],g[4]},{g[1],g[3]}}]
  local angle = anno.object[vo[l]].viewpoint.azimuth
  image.display{image=Ic,legend=cls[cl[l]]..' '..angle,zoom=3}
  image.display{image=image.hflip(Ic),legend=cls[cl[l]]..'_flip '..flip_angle(angle),zoom=3}
end


