do
print('Loading synthetic data from render4cnn')
  local add_bg = 1
  local nPoses = 24
  local divAng = 360/nPoses
  local tds = require 'tds'
  -- slightly modified to also read the targets
  local function read_render4cnn_data(file)
    -- get all lines from a file, returns an empty 
    -- list/table if the file does not exist
    if not paths.filep(file) then return {} end
    local lines = tds.Vec()--{}
    local targets = tds.Vec()----{}
    for line in io.lines(file) do
      local l = {}
      for i in string.gmatch(line, "%S+") do
        table.insert(l, i)
      end
      local cl_id = tonumber(l[2])+1
      local ang = tonumber(l[1]:sub(-22,-20))
      --table.insert(targets,{tonumber(l[2]), tonumber(l[1]:sub(-22,-20))})
      --table.insert(lines,l[1])
      --table.insert(targets, add_bg + (cl_id-2)*nPoses + math.fmod(math.ceil((ang-divAng/2)/divAng),nPoses)+1)
      lines:insert(l[1])
      targets:insert(add_bg + (cl_id-2)*nPoses + math.fmod(math.ceil((ang-divAng/2)/divAng),nPoses)+1)
    end
    return lines, targets
  end

  basefolder = '/media/francisco/Seagate Expansion Drive/francisco/work/datasets/render4cnn'

  imlist, targets = read_render4cnn_data(paths.concat(basefolder,'imglist.txt'))
  num_imgs = 9
  
  
function getBatch(bsize, lsize)

  local rootfolder = basefolder
  local im_size_x = 600--bsize[4]
  local im_size_y = 600--bsize[3]

  local context = 1.15
  local grid_size = math.sqrt(num_imgs)
  local step_size_x = im_size_x/grid_size
  local step_size_y = im_size_y/grid_size
  
  local min_step_size = math.min(step_size_x,step_size_y)
  
  local selected_imgs = torch.LongTensor(num_imgs):random(1, #imlist)
  local montage = torch.FloatTensor(1,3,im_size_y,im_size_x):zero()
  for i = 1, num_imgs do
    local select_img = selected_imgs[i]
    local im = image.load(paths.concat(rootfolder, imlist[select_img]), 3, 'float')
    im = im-0.5--image_transformer:preprocess(im)
    --print(im:size(),imlist[select_img])
    im = image.scale(im, min_step_size/context)
    local ims = im[1]:size()
    local x = (i-1)%grid_size
    local y = math.floor((i-1)/grid_size)
    local offset_x = (step_size_x-ims[2])/2
    local offset_y = (step_size_y-ims[1])/2
    local lmont = montage:narrow(3,y*step_size_y+1 + offset_y, ims[1]):narrow(4,x*step_size_x+1 + offset_x, ims[2])
    lmont:copy(im)
  end
  return montage
end

  
  
end
